//11may05 attempt to solofy gkf
/* 	Quasicrystal program
	This program uses the projection
	method, specifically, it uses a
	projection matrix given to me by
	Tony Robbin. When it calculates the
	edges, the order of growth of the
	computing time is quadratic, so a
	2x2x2x2x2x2 hypercube is about as
	big as it can handle, and even that
	will take awhile to calculate.

	Adam Harrell			*/

//#pragma comment( linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"" )


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <stdlib.h>
#include <stdio.h>
//#include <windows.h> //    used only to compile on my windows machine at home
//#include <GL/gl.h>  //for linux
//#include <GL/glut.h>  //for linux
#include <glut.h>
#include <math.h>
//***************
//#include "hyperObject.h"

#ifndef hyperObject_h
#define hyperObject_h

#include <stdio.h>
//********************
//#include "hyperVertex.h"

#ifndef hyperVertex_h
#define hyperVertex_h

//#include <windows.h>

class hyperVertex
{
public:
	hyperVertex();
	hyperVertex(double a,double b,double c,double d,double e,double f);
	
	void setCoords(double a,double b,double c,double d,double e,double f);

	bool isMatch(double a,double b,double c,double d,double e,double f);

	double getX();
	double getY();
	double getZ();
	double getU();
	double getV();
	double getW();

private:
	double x,y,z,u,v,w;
		
};
#endif
//********************
//#include <windows.h>
#include <stdlib.h>
#include <glut.h>

class hyperObject
{
public:
	hyperObject();
	int getSize();

	void addVertex(double x, double y, double z, double u, double v, double w);
	void generateProjection();

	void drawObject();
	void drawProjection();
	

private:
	void calculateEdges();
	// A lot of these are legacy variables, I will go through some time and remove
	// unneeded variables.
	float a,b,c,d,e,f,g;
	float an,bn,cn,dn,en,fn,gn;
	float xn,yn,zn,un,vn,wn;
	float xnn,ynn,znn,unn,vnn,wnn;
	float edgeLowerBound, edgeUpperBound;
	int size, edgeSize;
	hyperVertex* vertexList;
	hyperVertex* projectionList;
	hyperVertex* edgeList;			// Holds the list of quasi edges to be drawn
	
};



#endif

//***************

hyperObject *myObject;
GLfloat angle = 0;
GLfloat angle2 = 0;
GLfloat angleInRads;
int moving, startx, starty;
float xPos, yPos, zPos = 0;
const float twopi = 2 * 3.14159;
float slope = 0.61803;

// Whether or not to draw the original hypercube with
// higher dimensions dropped.

// Leave OFF for now, edge drawing has not been optimized
// for this, you will end up with thousands of duplicate
// edges that slow the simulation to a crawl.
bool cubeToggle = false;

/******************************************/
void display()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glPushMatrix();

	glRotatef(angle2, 1.0, 0, 0);
	glRotatef(angle, 0, 1.0, 0);
	glTranslatef(xPos,yPos,zPos);

	glTranslatef(-2.0f, 0, -2.0f);
	glColor3f(1,1,1);

	if (cubeToggle)
		myObject->drawObject();

	glTranslatef(2.0f, 0, -2.0f);
	glColor3f(0,1,0);

	myObject->drawProjection();

	glPopMatrix();

	glutSwapBuffers();

}
/******************************************/

/******************************************/
void initObject()	// Used to initialize our hyper Object
{
	// If you want to increase the number of hypercubes,
	// increase the size of these for loops, each for loop
	// expands the cube in a different dimension. Not recommended
	// that you increase the loops above 2 iterations each, or
	// the cube will take forever to initialize, and may run out
	// of memory during edge calculation.
	myObject = new hyperObject();
	for (int i = 0; i < 1; i++)
	{
	for (int j = 0; j < 1; j++)
	{
	for (int k = 0; k < 1; k++)
	{
	for (int l = 0; l < 1; l++)
	{
	for (int m = 0; m < 1; m++)
	{
	for (int n = 0; n < 1; n++)
	{
	myObject->addVertex(i,j,k,l,m,n);
	myObject->addVertex(i,j,k,l,m,n+1);
	myObject->addVertex(i,j,k,l,m+1,n);
	myObject->addVertex(i,j,k,l,m+1,n+1);
	myObject->addVertex(i,j,k,l+1,m,n);
	myObject->addVertex(i,j,k,l+1,m,n+1);
	myObject->addVertex(i,j,k,l+1,m+1,n);
	myObject->addVertex(i,j,k,l+1,m+1,n+1);
	myObject->addVertex(i,j,k+1,l,m,n);
	myObject->addVertex(i,j,k+1,l,m,n+1);
	myObject->addVertex(i,j,k+1,l,m+1,n);
	myObject->addVertex(i,j,k+1,l,m+1,n+1);
	myObject->addVertex(i,j,k+1,l+1,m,n);
	myObject->addVertex(i,j,k+1,l+1,m,n+1);
	myObject->addVertex(i,j,k+1,l+1,m+1,n);
	myObject->addVertex(i,j,k+1,l+1,m+1,n+1);
	myObject->addVertex(i,j+1,k,l,m,n);
	myObject->addVertex(i,j+1,k,l,m,n+1);
	myObject->addVertex(i,j+1,k,l,m+1,n);
	myObject->addVertex(i,j+1,k,l,m+1,n+1);
	myObject->addVertex(i,j+1,k,l+1,m,n);
	myObject->addVertex(i,j+1,k,l+1,m,n+1);
	myObject->addVertex(i,j+1,k,l+1,m+1,n);
	myObject->addVertex(i,j+1,k,l+1,m+1,n+1);
	myObject->addVertex(i,j+1,k+1,l,m,n);
	myObject->addVertex(i,j+1,k+1,l,m,n+1);
	myObject->addVertex(i,j+1,k+1,l,m+1,n);
	myObject->addVertex(i,j+1,k+1,l,m+1,n+1);
	myObject->addVertex(i,j+1,k+1,l+1,m,n);
	myObject->addVertex(i,j+1,k+1,l+1,m,n+1);
	myObject->addVertex(i,j+1,k+1,l+1,m+1,n);
	myObject->addVertex(i,j+1,k+1,l+1,m+1,n+1);
	myObject->addVertex(i+1,j,k,l,m,n);
	myObject->addVertex(i+1,j,k,l,m,n+1);
	myObject->addVertex(i+1,j,k,l,m+1,n);
	myObject->addVertex(i+1,j,k,l,m+1,n+1);
	myObject->addVertex(i+1,j,k,l+1,m,n);
	myObject->addVertex(i+1,j,k,l+1,m,n+1);
	myObject->addVertex(i+1,j,k,l+1,m+1,n);
	myObject->addVertex(i+1,j,k,l+1,m+1,n+1);
	myObject->addVertex(i+1,j,k+1,l,m,n);
	myObject->addVertex(i+1,j,k+1,l,m,n+1);
	myObject->addVertex(i+1,j,k+1,l,m+1,n);
	myObject->addVertex(i+1,j,k+1,l,m+1,n+1);
	myObject->addVertex(i+1,j,k+1,l+1,m,n);
	myObject->addVertex(i+1,j,k+1,l+1,m,n+1);
	myObject->addVertex(i+1,j,k+1,l+1,m+1,n);
	myObject->addVertex(i+1,j,k+1,l+1,m+1,n+1);
	myObject->addVertex(i+1,j+1,k,l,m,n);
	myObject->addVertex(i+1,j+1,k,l,m,n+1);
	myObject->addVertex(i+1,j+1,k,l,m+1,n);
	myObject->addVertex(i+1,j+1,k,l,m+1,n+1);
	myObject->addVertex(i+1,j+1,k,l+1,m,n);
	myObject->addVertex(i+1,j+1,k,l+1,m,n+1);
	myObject->addVertex(i+1,j+1,k,l+1,m+1,n);
	myObject->addVertex(i+1,j+1,k,l+1,m+1,n+1);
	myObject->addVertex(i+1,j+1,k+1,l,m,n);
	myObject->addVertex(i+1,j+1,k+1,l,m,n+1);
	myObject->addVertex(i+1,j+1,k+1,l,m+1,n);
	myObject->addVertex(i+1,j+1,k+1,l,m+1,n+1);
	myObject->addVertex(i+1,j+1,k+1,l+1,m,n);
	myObject->addVertex(i+1,j+1,k+1,l+1,m,n+1);
	myObject->addVertex(i+1,j+1,k+1,l+1,m+1,n);
	myObject->addVertex(i+1,j+1,k+1,l+1,m+1,n+1);
	}}}}}}

	myObject->generateProjection();
}

/******************************************/

/******************************************/
void mouse(int button, int state, int x, int y)
{
  if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
    moving = 1;
    startx = x;
    starty = y;
  }
  if (button == GLUT_LEFT_BUTTON && state == GLUT_UP) {
    moving = 0;
  }
}
/******************************************/

/******************************************/
void motion(int x, int y)
{
  if (moving) {
    angle = angle + (x - startx);
    angle2 = angle2 + (y - starty);
    startx = x;
    starty = y;
    glutPostRedisplay();
  }
}
/******************************************/

/******************************************/
void keyboard(unsigned char key, int x, int y)
{
	angleInRads = (angle / 360.0f) * (twopi);
	// Camera controls in here
	switch(key)
	{
		case 'c': cubeToggle = !cubeToggle;glutPostRedisplay();break;
		case 'w': xPos += 0.1 * (cos(angleInRads + (twopi/4)));zPos += 0.1 * (sin(angleInRads + (twopi/4)));glutPostRedisplay(); break;
		case 's': xPos -= 0.1 * (cos(angleInRads + (twopi/4)));zPos -= 0.1 * (sin(angleInRads + (twopi/4)));glutPostRedisplay(); break;
		case 'a': xPos += 0.1 * (cos(angleInRads));zPos += 0.1 * (sin(angleInRads));glutPostRedisplay(); break;
		case 'd': xPos -= 0.1 * (cos(angleInRads));zPos -= 0.1 * (sin(angleInRads));glutPostRedisplay(); break;
		case 'e': yPos -= 0.1;glutPostRedisplay(); break;
		case 'q': yPos += 0.1;glutPostRedisplay(); break;
		case  27: exit(0); break;        /* escape with the  (ESC) key  */
	}
}

/******************************************/

void idle()
{}

/******************************************/
int main(int argc, char **argv)
{
  initObject();
 // glLineWidth(3.0);	/* This doesn't seem to do anything   =( */
  glutInitWindowSize(400,400);
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
  glutCreateWindow("<< QuasiCrystals in GLUT >>");
  glutDisplayFunc(display);
  glutKeyboardFunc(keyboard);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutIdleFunc(idle);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(45.0, 1.0, 1.0, 200.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glutMainLoop();
  return 0;
}
//*********************
#include <math.h>
//#include <windows.h>
//#include <GL/gl.h>  not on mac
//#include <GL/glut.h>  not on mac

/* NOTE TO SELF
   May have to change distance calculation method
   From 5d plane to 3d plane
   Figure out how to calculate that distance
*/

hyperObject::hyperObject()
{
	size = edgeSize = 0;
	a = b = c = d = e = f = g = 0;
	xn = yn = zn = un = vn = wn = 0;

	// Set these to change the crystal edges
	// However, the vast majority of bounds
	// yield terrible results.
	edgeLowerBound = 0.59;
	edgeUpperBound = 0.592;

	vertexList = NULL;
	projectionList = NULL;
	edgeList = NULL;
}


int hyperObject::getSize()
{
	return size;
}

void hyperObject::addVertex(double x, double y, double z, double v, double u, double w)
{
	if (size == 0)
		{
			vertexList = new hyperVertex(x,y,z,v,u,w);
			size++;
		}

	else
	{
		double xt,yt,zt,ut,vt,wt;
		hyperVertex* tempList = new hyperVertex[size + 1];
		for (int i = 0; i < size; i++)
		{
			xt = vertexList[i].getX();
			yt = vertexList[i].getY();
			zt = vertexList[i].getZ();
			ut = vertexList[i].getU();
			vt = vertexList[i].getV();
			wt = vertexList[i].getW();

			tempList[i].setCoords(xt,yt,zt,ut,vt,wt);
		}

		tempList[size].setCoords(x,y,z,u,v,w);
		delete vertexList;
		vertexList = tempList;
		size++;
	}
}


void hyperObject::generateProjection()
{
	double xt,yt,zt,ut,vt,wt;
	double dist,distNorm;


	hyperVertex *tempList = new hyperVertex[size];

	// The formatting on this matrix looked a lot better on my computer at home
	// Anyway, this is the projection matrix that drops the points of the 6D hypercube
	// to 3D according to the 3D hyperplane that passes through at the golden angle
	float matrixArray[36] = {-sqrt(5),		1,		1,		1,		1,		1
							 ,		1,sqrt(5),		1,		-1,		-1,		1	
							 ,		1,		1,	sqrt(5),	1,		-1,		-1
							 ,		1,		-1,		1,	sqrt(5),	1,		-1
							 ,		1,		-1,		-1,		1,sqrt(5),		1
							 ,sqrt(5),		1,		-1,		-1,		1,	sqrt(5)};

	// All matrix values must be multiplied by this to complete it
	for (int j = 0; j < 36; j++)
	{
		matrixArray[j] *= (1 / sqrt(20));
	}

	float pointArray[6];

	// C++ has no built-in matrix math, so do it by hand
	for (int i = 0; i < size; i++)
	{
		xt = vertexList[i].getX();
		yt = vertexList[i].getY();
		zt = vertexList[i].getZ();
		ut = vertexList[i].getU();
		vt = vertexList[i].getV();
		wt = vertexList[i].getW();

		pointArray[0] = (xt*matrixArray[0]) + (yt*matrixArray[6]) + (zt*matrixArray[12]) +
						(ut*matrixArray[18]) + (vt*matrixArray[24]) + (wt*matrixArray[30]);
		pointArray[1] = (xt*matrixArray[1]) + (yt*matrixArray[7]) + (zt*matrixArray[13]) +
						(ut*matrixArray[19]) + (vt*matrixArray[25]) + (wt*matrixArray[31]);
		pointArray[2] = (xt*matrixArray[2]) + (yt*matrixArray[8]) + (zt*matrixArray[14]) +
						(ut*matrixArray[20]) + (vt*matrixArray[26]) + (wt*matrixArray[32]);
		pointArray[3] = (xt*matrixArray[3]) + (yt*matrixArray[9]) + (zt*matrixArray[15]) +
						(ut*matrixArray[21]) + (vt*matrixArray[27]) + (wt*matrixArray[33]);
		pointArray[4] = (xt*matrixArray[4]) + (yt*matrixArray[10]) + (zt*matrixArray[16]) +
						(ut*matrixArray[22]) + (vt*matrixArray[28]) + (wt*matrixArray[34]);
		pointArray[5] = (xt*matrixArray[5]) + (yt*matrixArray[11]) + (zt*matrixArray[17]) +
						(ut*matrixArray[23]) + (vt*matrixArray[29]) + (wt*matrixArray[35]);

		tempList[i].setCoords(pointArray[0],pointArray[1],pointArray[2],pointArray[3],pointArray[4],pointArray[5]);
	}

		if (projectionList != NULL)
			delete projectionList;
		projectionList = tempList;
		calculateEdges();
}

void hyperObject::drawObject()
{
	double x1,x2,y1,y2,z1,z2;
	double dist;

	glBegin(GL_LINES);
	for (int i = 0; i < size; i++)
	{
		for (int j = 0; j < size; j++)
		{
			x1 = vertexList[i].getX();
			x2 = vertexList[j].getX();
			y1 = vertexList[i].getY();
			y2 = vertexList[j].getY();
			z1 = vertexList[i].getZ();
			z2 = vertexList[j].getZ();

			dist = sqrt(pow(x2-x1,2) + pow(y2-y1,2) + pow(z2-z1,2));

			if (dist <= 1)
			{
				glVertex3f(x1,y1,z1);
				glVertex3f(x2,y2,z2);
			}
		}
	}
	glEnd();
}

void hyperObject::drawProjection()
{
	double x1,x2,y1,y2,z1,z2;

	glBegin(GL_LINES);
	for (int i = 0; i < edgeSize; i+=2)
	{
		x1 = edgeList[i].getX();
		x2 = edgeList[i+1].getX();
		y1 = edgeList[i].getY();
		y2 = edgeList[i+1].getY();
		z1 = edgeList[i].getZ();
		z2 = edgeList[i+1].getZ();

		glVertex3f(x1,y1,z1);
		glVertex3f(x2,y2,z2);
	}
	glEnd();
}

void hyperObject::calculateEdges()
{
	edgeSize = 0;
	double dist;
	double x1,x2,y1,y2,z1,z2;
	// Need to loop three times; once to find the number of edges, once 
	// to put them in an array, once to cull the duplicate edges
	for (int i = 0; i < size; i++)
	{
		for (int j = i; j < size; j++)
		{
			if (i != j)
			{	
				x1 = projectionList[i].getX();
				x2 = projectionList[j].getX();
				y1 = projectionList[i].getY();
				y2 = projectionList[j].getY();
				z1 = projectionList[i].getZ();
				z2 = projectionList[j].getZ();

				if (x1 == -100 || x2 == -100)
					dist = 100000;
				else
					dist = sqrt(pow(x2-x1,2) + pow(y2-y1,2) + pow(z2-z1,2));
			}
			
			else
				dist = 0;

			if (dist > edgeLowerBound && dist < edgeUpperBound)
				edgeSize += 2;
			
		}
	}

	hyperVertex* tempList = new hyperVertex[edgeSize];
	int counter = 0;

	for (int ii = 0; ii < size; ii++)
	{
		for (int j = ii; j < size; j++)
		{
			if (ii != j)
			{	
				x1 = projectionList[ii].getX();
				x2 = projectionList[j].getX();
				y1 = projectionList[ii].getY();
				y2 = projectionList[j].getY();
				z1 = projectionList[ii].getZ();
				z2 = projectionList[j].getZ();

				dist = sqrt(pow(x2-x1,2) + pow(y2-y1,2) + pow(z2-z1,2));
			}
			
			else
				dist = 0;

			if (dist > edgeLowerBound && dist < edgeUpperBound)
			{
				tempList[counter].setCoords(x1,y1,z1,0,0,0);
				tempList[counter+1].setCoords(x2,y2,z2,0,0,0);
				counter += 2;
			}
		}
	}

	int cullSize = 0;
	hyperVertex* cullList = new hyperVertex[edgeSize];
	double xt1,xt2,yt1,yt2,zt1,zt2;
	for (int iii = 0; iii < edgeSize; iii+=2)
	{
		x1 = tempList[iii].getX();
		x2 = tempList[iii + 1].getX();
		y1 = tempList[iii].getY();
		y2 = tempList[iii + 1].getY();
		z1 = tempList[iii].getZ();
		z2 = tempList[iii + 1].getZ();
		if (cullSize == 0)
		{
			cullList[0].setCoords(x1,y1,z1,0,0,0);
			cullList[1].setCoords(x2,y2,z2,0,0,0);
			cullSize = 2;
		}

		else
		{
			for (int j = 0; j < cullSize; j+=2)
			{
				xt1 = cullList[j].getX();
				xt2 = cullList[j + 1].getX();
				yt1 = cullList[j].getY();
				yt2 = cullList[j + 1].getY();
				zt1 = cullList[j].getZ();
				zt2 = cullList[j + 1].getZ();
				
				if (x1 == xt1 && x2 == xt2 && y1 == yt1 && y2 == yt2 && z1 == zt1 && z2 == zt2)
				{
					tempList[iii].setCoords(-100,0,0,0,0,0);
					j = cullSize;
				}
			}

			if (tempList[iii].getX() != -100)
			{
				cullList[cullSize].setCoords(x1,y1,z1,0,0,0);
				cullList[cullSize+1].setCoords(x2,y2,z2,0,0,0);
				cullSize += 2;
			}
		}
	}

	delete tempList;
	tempList = new hyperVertex[cullSize];
	for (int c = 0; c < cullSize; c+=2)
	{
		x1 = cullList[c].getX();
		x2 = cullList[c + 1].getX();
		y1 = cullList[c].getY();
		y2 = cullList[c + 1].getY();
		z1 = cullList[c].getZ();
		z2 = cullList[c + 1].getZ();

		tempList[c].setCoords(x1,y1,z1,0,0,0);
		tempList[c+1].setCoords(x2,y2,z2,0,0,0);
	}

	delete cullList;
	
	if (edgeList != NULL)
		delete edgeList;

	edgeList = tempList;
	edgeSize = cullSize;
}
//*****************************		

hyperVertex::hyperVertex()
{
	x = 0;
	y = 0;
	z = 0;
	w = 0;
	u = 0;
	v = 0;
}

hyperVertex::hyperVertex(double a, double b, double c, double d,double e,double f)
{
	x = a;
	y = b;
	z = c;
	u = d;
	v = e;
	w = f;
}

void hyperVertex::setCoords(double a, double b, double c, double d,double e,double f)
{
	x = a;
	y = b;
	z = c;
	u = d;
	v = e;
	w = f;
}

bool hyperVertex::isMatch(double a, double b, double c, double d,double e,double f)
{
	if (a == x && b == y && c == z && d == u && e == v && f == w)
		return true;
	return false;
}

double hyperVertex::getX()
{
	return x;
}

double hyperVertex::getY()
{
	return y;
}

double hyperVertex::getZ()
{
	return z;
}

double hyperVertex::getU()
{
	return u;
}

double hyperVertex::getV()
{
	return u;
}

double hyperVertex::getW()
{
	return w;
}
		
	

